/* This is the library of routines that are used by the contestants to
   simulate dropping the objects.

		A compiled version of this library was given to each contestant.
	  The source code was not given to them.
*/


unit level;

interface

function GetN:integer ;
function GetD:integer ;
function Drop( level:integer ) : integer ;
procedure Decide( level:integer ) ;

implementation


const MAX_N = 100;
const NUM_BALLS = 2;

var
  N, D, H, drops_left, balls_left : integer;
  init : integer;
  outlog : text;
  logopen : integer;



procedure error_quit(  msg:string );
begin
        write('Level Library: Error: ');
        writeln(msg);
        writeln('The Level Library is terminating your program.');
        if logopen = 1 then
        begin
                write(outlog,'Level Library: Error: ');
                writeln(outlog,msg);
                writeln(outlog,'The Level Library is terminating your program.');
        end;                
				halt(1);
end;

procedure initialize;
var
        infp, outfp : text;
begin

 if init = 0 then
 begin

{$I-}
        assign(outlog,'level.log');
        rewrite(outlog);

        if IOResult <> 0 then error_quit( 'Cannot open output file level.log' );
        writeln(outlog,'Starting simulation');
        flush(outlog);
        logopen := 1;


{$I-}
        assign(outfp,'level.out');
        rewrite(outfp);

        if IOResult <> 0 then error_quit( 'Cannot open output file level.out' );
        writeln(outfp,'No value was passed to decide');
        close(outfp);

{$I-}
        assign(infp,'level.in');
        reset(infp);

        if( IOResult <> 0 ) then                error_quit( 'Unable to open level.in' );
        read(infp,N);
if IOResult <> 0 then error_quit( 'Unable to read three integers from level.in');
        read(infp,D);
if IOResult <> 0 then error_quit( 'Unable to read three integers from level.in');
        read(infp,H);
if IOResult <> 0 then error_quit( 'Unable to read three integers from level.in');

        close( infp );
if IOResult <> 0 then error_quit( 'Unable to read three integers from level.in');


        if (N<0)  or  (N>MAX_N)   then
                error_quit( 'Invalid value for N in level.in');
				if (D<0) or (D>N)   then
                error_quit( 'Invalid value for D in level.in');
        if (H<1) or (H>N)    then
               error_quit( 'Invalid value for H in level.in');

        (* success *)
				drops_left := D;
				balls_left := NUM_BALLS;
        writeln(outlog,'Reading parameters from level.in:');
        writeln(outlog,'    N=',N,', D=',D,', H=',H);
        flush(outlog);
				init := 1;
  end; (* if init = 0 *)
end;

function GetN: integer;
begin
        initialize;
        writeln(outlog,'GetN returning ',N);
        flush(outlog);
        GetN := N;
end;

function GetD: integer;
begin
	initialize  ;
        writeln(outlog,'GetD returning ',D);
        flush(outlog);
	GetD :=D;
end;

function Drop( level:integer ) :integer;
begin
        initialize;
        writeln(outlog,'Drop(',level,')');
        flush(outlog);


	if( balls_left<1 ) then
		error_quit( 'Cannot perform drop: the two samples have already broken');
	if( drops_left<1 ) then
		error_quit( 'Cannot perform drop: drop limit exceeded');

	if( (level<1) or (level>N) ) then
		error_quit( 'Cannot perform drop: invalid level');

	drops_left := drops_left - 1;
	if( level >= H ) then
        begin
								balls_left := balls_left - 1;
                writeln(outlog,'    Drop returning 1');
                flush(outlog);
                Drop := 1;
        end;

	(* bug fix: "level <= H" *)
	if( level < H ) then
        begin
              writeln(outlog,'    Drop returning 0');
              flush(outlog);
              Drop := 0;
        end;
end;

procedure Decide(  level:integer );
var
        outfp : text;
begin
        initialize;
        writeln(outlog,'Decide(',level,')');
        flush(outlog);
{$I-}
        assign(outfp,'level.out');
        rewrite(outfp);

        if( IOResult <> 0 )    then
             error_quit( 'Cannot open output file level.out' );

        writeln(outfp,level);

				close(outfp);

        if level = H then
        begin
                writeln(outlog,'    Congratulations! You have found the breaking level.');
        end;
        if level <> H then
        begin
                writeln(outlog,'    Your answer is incorrect.');
                writeln(outlog,'    The correct answer is ',H);
        end;
        writeln(outlog,'Ending simulation');
        flush(outlog);
        close(outlog);
        halt(0);
        init:=0;
end;

begin
        init := 0;
        logopen := 0;
end.
